.plugin asm86    ; make sure we make a TI-86 program with Assembly
; Studio 8X 4.0. The reason I didn't use an #include is because we
; want this to be a standalone source. Also, having a header for only
; 2 needed equates is stupid

plotsscreen equ $FC00 ; address in RAM for the graph screen

.org $D748       ; point to where programs are loaded in RAM

 ld (hl),$FF     ; (address value) = 255
 ; load the address the 16-bit register, hl, points to with 255 (aka $FF)
LoopDown:        ; this loop decreases until the screen is blank
 call FillScreen ; executes subroutine to fill the screen with the value in hl's address
 dec (hl)        ; decrease the value in hl's address
 ld a,(hl)       ; save it to the accumulator
 or a            ; compare the accumulator to zero; a=0?
 jr nz,LoopDown  ; if it's not zero, continue looping

; This routine is called from the loop to fill the screen with a
; value. the graphical effect seems to shutter from black to white
; notice there's no "ret" after the loops exiting statement that
; means when a=0 it'll run this screen filler for the last time,
; outside the loop thereby clearing the screen (filling graphics
; screen with zeros) and finally exiting

FillScreen:
 ld a,(hl)       ; load the accumulator with the value from (hl)
 push af         ; save 16-bit pair af to the stack
 ld de,plotsscreen+1 ; load 16-bit register pair de with screen address+1
 ld hl,plotsscreen   ; load 16-bit register pair hl with screen address
 ld bc,1023      ; set the 16-bit reg pair bc with 1023 (byte size of screen - 1)
 pop af          ; restore 16-bit pair af from the stack
 ld (hl),a       ; save to the address hl points to
 ldir            ; copy byte, increase de and hl, decrease bc, repeat until bc=0
 ret             ; return from the routine, and finally exit after the last loop

.end    ; end of program and code